/**
 * SelectMenuItem.java -        
 */

package jbible.mobile.ui;

import javax.microedition.lcdui.*;
import java.io.*;
import jbible.mobile.*;

/**
 *       
 * @author Konstantin K. Beliak, e-mail: <a href="mailto:smbadm@yandex.ru">smbadm@yandex.ru</a>
 */
public abstract class SelectMenuItem extends MenuItem {
    
    /**
     *  
     */
    private int itemCount;
    
    /**
     *   
     */
    private int selIndex;
    /**
     *  
     */
    //private static Image left;
    /**
     *  
     */
    //private static Image right;
    /**
     *   
     */
    //private static Image leftInactive;
    
    /**
     *   
     */
    //private static Image rightInactive;
    
    /**
     *   (    )
     */
    private final int INSPACE=10;
    
    /**
     *  y   
     */
    private int centerY;
    
    /**
     *  
     */
    private int rectWidth;
    
    /**
     *  
     */
    private String text;
    
    /**
     *  
     */
    private Canvas owner;
    
    /*static{
        try{
            left=Image.createImage("/"+Common.IMGS_DIR+"/left.png");
            right=Image.createImage("/"+Common.IMGS_DIR+"/right.png");
            leftInactive=Image.createImage("/"+Common.IMGS_DIR+"/left_inactive.png");
            rightInactive=Image.createImage("/"+Common.IMGS_DIR+"/right_inactive.png");

        }catch(IOException e){
            throw new IllegalStateException("Can't load images for SelectMenuItem component");
        }
    }*/
    
    /**
     *    
     * @param itemCount    
     * @param selIndex   
     * @param owner  
     */
    public SelectMenuItem(int itemCount, int selIndex,Canvas owner) {
        this.itemCount=itemCount;
        this.selIndex=selIndex;
        this.owner=owner;
    }
    
    /**
     *            
     */
    public void update(){
        centerY=getY()+getHeight()/2;
        rectWidth=getWidth()-(2*Common.SETTINGS.getHorizontalSpace()+2*INSPACE/*+left.getWidth()+right.getWidth()*/);
        Font f=Font.getDefaultFont();
        text=getItemText(selIndex);
        StringBuffer buf=new StringBuffer(text);
        String append="";
        while(f.stringWidth(buf.toString()+append)>rectWidth-Common.SETTINGS.getHorizontalSpace()*2 && buf.length()>0){
            buf.deleteCharAt(buf.length()-1);
            append="..";
        }
        text=buf+append;
        owner.repaint();
    }
    
    /**
     *     (       )
     * @param index   
     * @return   
     */
    public abstract String getItemText(int index);
    
    /**
     *    
     * @param index  
     */
    public abstract void select(int index);
    
    /**
     *   
     * @param index  
     */
    public void setSelectedIndex(int index){
        selIndex=index;
        select(selIndex);
        update();
    }
    
    /**
     *   
     * @param count  
     */
    public void setItemCount(int count){
        this.itemCount=count;
        this.selIndex=0;
        select(selIndex);
        update();
    }
    
    /**
     *    ( )
     * @param action   (   getGameAction)
     */
    public void action(int action){
        switch(action){
            case Canvas.RIGHT:
                if(selIndex<itemCount-1) selIndex++; else selIndex=0;
                select(selIndex);
                update();
                break;
            case Canvas.LEFT:
                if(selIndex>0) selIndex--; else selIndex=itemCount-1;
                select(selIndex);
                update();
                break;                
        }
    }
    
    /**
     *   
     * @param g   
     */
    public void paint(Graphics g){
        //if(Common.SETTINGS.useSimpleMenu()){
            g.setColor((isActive()?Common.SETTINGS.getBgTextColor():Common.SETTINGS.getBgTitleColor()));
            if(isActive()) g.fillRect(Common.SETTINGS.getHorizontalSpace()+/*left.getWidth()*/+INSPACE,getY()+1,rectWidth,getHeight()-1);
            g.setColor((isActive()?Common.SETTINGS.getFgTitleColor():Common.SETTINGS.getFgTextColor()));
            g.drawString(text,getWidth()/2,getY()+Common.SETTINGS.getVerticalSpace(),Graphics.TOP | Graphics.HCENTER);
            if(isActive())g.drawRect(Common.SETTINGS.getHorizontalSpace()+/*left.getWidth()*/+INSPACE,getY()+1,rectWidth,getHeight()-1);
        /*}else{
            Image leftImg=(isActive())?left:leftInactive;
            Image rightImg=(isActive())?right:rightInactive;
            //g.setColor((isActive()?Common.SETTINGS.getBgTextColor():Common.SETTINGS.getBgTitleColor()));
            //if(isActive() && Common.SETTINGS.useSimpleMenu()) g.fillRect(Common.SETTINGS.getHorizontalSpace()+left.getWidth()+INSPACE,getY(),rectWidth,getHeight());
            g.setColor((isActive()?Common.SETTINGS.getFgTitleColor():Common.SETTINGS.getFgTextColor()));
            g.drawString(text,getWidth()/2,getY()+Common.SETTINGS.getVerticalSpace(),Graphics.TOP | Graphics.HCENTER);
            //if(isActive() && Common.SETTINGS.useSimpleMenu())g.drawRect(Common.SETTINGS.getHorizontalSpace()+left.getWidth()+INSPACE,getY(),rectWidth,getHeight());
            int strW=g.getFont().stringWidth(text);
            if(itemCount>1) g.drawImage(leftImg,(getWidth()-strW)/2-2*Common.SETTINGS.getHorizontalSpace(),centerY,Graphics.RIGHT | Graphics.VCENTER);
            if(itemCount>1) g.drawImage(rightImg,getWidth()-(getWidth()-strW)/2+2*Common.SETTINGS.getHorizontalSpace(),centerY,Graphics.LEFT | Graphics.VCENTER);
        }*/
    }

    /**
     *    
     * @return   
     */
    public int getSelectedIndex() {
        return selIndex;
    }
    
}
